-- SwitchView UI version 0.1.1 by VitaHEX
-- https://www.patreon.com/vitahex
local working_dir = "ux0:/app"
function System.currentDirectory(dir)
	if dir == nil then
		return working_dir
	else
		working_dir = dir
	end
end

Sound.init()
local click = Sound.open("app0:/UI/click1.wav")
local imgTmp = Graphics.loadImage("app0:/UI/noimg.png")
local imgCart = Graphics.loadImage("app0:/UI/cart.png")
local imgAvatar = Graphics.loadImage("app0:/AVATARS/AV01.png")
local imgCont = Graphics.loadImage("app0:/UI/cont.png")
local btnX = Graphics.loadImage("app0:/UI/x.png")
local imgBattery = Graphics.loadImage("app0:/UI/bat.png")
local btnMenu1 = Graphics.loadImage("app0:/UI/btm1.png")
local btnMenu2 = Graphics.loadImage("app0:/UI/btm2.png")
local btnMenu3 = Graphics.loadImage("app0:/UI/btm3.png")
local btnMenu4 = Graphics.loadImage("app0:/UI/btm4.png")
local btnMenu5 = Graphics.loadImage("app0:/UI/btm5.png")
local btnMenu6 = Graphics.loadImage("app0:/UI/btm6.png")
local btnMenuSel = Graphics.loadImage("app0:/UI/selct.png")

local img_path = ""

local fnt = Font.load("app0:/UI/font.ttf")
local bottomMenu = false
local menuSel = 1
local menuX = 0

info = System.extractSfo("app0:/sce_sys/param.sfo")
app_version = info.version
app_title = info.title
app_category = info.category
app_titleid = info.titleid

function OneshotPrint(my_func)
	my_func()
	Screen.flip()
	my_func()
	Screen.flip()
	my_func()
end

-- Speed related settings
local cpu_speed = 333
System.setBusSpeed(222)
System.setGpuSpeed(222)
System.setGpuXbarSpeed(166)
System.setCpuSpeed(cpu_speed)

-- Functions used by filebrowser
local function CropPrint(x, y, text, color, icon)
	Graphics.setImageFilters(icon, FILTER_LINEAR, FILTER_LINEAR)
	Graphics.drawScaleImage(x, y, icon, 1.5, 1.5)
end
function TableConcat(t1,t2)
    for i=1,#t2 do
        t1[#t1+1] = t2[i]
    end
    return t1
end

function SelectBottomMenu()
	if menuSel==1 then
	System.executeUri("wbapp0:")
	elseif menuSel==2 then
	System.executeUri("psns:")
	elseif menuSel==3 then
	System.executeUri("photo:")
	elseif menuSel==4 then
	System.executeUri("scecomboplay:")
	elseif menuSel==5 then
	System.executeUri("settings_dlg:")
	elseif menuSel==6 then
	Graphics.freeImage(imgTmp)
	Graphics.freeImage(imgCart)
	Graphics.freeImage(imgAvatar)
	Graphics.freeImage(btnX)
	Graphics.freeImage(imgBattery)
	Graphics.freeImage(btnMenu1)
	Graphics.freeImage(btnMenu2)
	Graphics.freeImage(btnMenu3)
	Graphics.freeImage(btnMenu4)
	Graphics.freeImage(btnMenu5)
	Graphics.freeImage(btnMenu6)
	Graphics.freeImage(btnMenuSel)
	System.exit()
	end
end

function listDirectory(dir)
	dir = System.listDirectory(dir)
	folders_table = {}
	files_table = {}
	for i,file in pairs(dir) do
		if file.directory then
			table.insert(folders_table,file)
		elseif (string.lower(string.sub(file.name,-4)) == ".obj") then
			if string.sub(file.name,1,1) ~= "." then
				table.insert(files_table,file)
			end
		end
		img_path = "ur0:/appmeta/" .. file.name .. "/icon0.png"
			if not pcall(loadImage, img_path) then 
				imgTmp = Graphics.loadImage("app0:/UI/noimg.png")
				file.icon=imgTmp
				table.insert(files_table, 4,file.icon)
			else
				imgTmp = Graphics.loadImage(img_path)
				file.icon=imgTmp
				table.insert(files_table, 4,file.icon)
			end
	end
	table.sort(files_table, function (a, b) return (a.name:lower() < b.name:lower() ) end)
	table.sort(folders_table, function (a, b) return (a.name:lower() < b.name:lower() ) end)
	return_table = TableConcat(folders_table,files_table)
	return return_table
end
function OpenDirectory(text)
	i=0
	if text == ".." then
		j=-2
		while string.sub(System.currentDirectory(),j,j) ~= "/" do
			j=j-1
		end
		System.currentDirectory(string.sub(System.currentDirectory(),1,j))
	else
		System.currentDirectory(System.currentDirectory()..text.."/")
	end
	files_table = listDirectory(System.currentDirectory())
	if System.currentDirectory() ~= "ux0:/" then
		local extra = {}
		extra.name = ".."
		extra.size = 0
		extra.directory = true
		extra.icon = "tester"
		table.insert(files_table,extra)
	end
end

function loadImage (img_path) 
	imgTmp = Graphics.loadImage(img_path) 
end

-- Starting filebrowser
files_table = listDirectory(System.currentDirectory())
local master_index = 0
local p = 1
local oldpad = 0

-- Init a couple of colors
local black = Color.new(0,0,0)
local grey = Color.new(45,45,45) 
local white = Color.new(255,255,255)
local red = Color.new(255, 0, 0)
local yellow = Color.new(255, 255, 0)
local blue = Color.new(67,178,255)
local cyan = Color.new(0,254,202)
local bg = Color.new(153,217,234)

-- Main loop
while true do
		
	-- Reading input
	pad = Controls.read()

	-- Initializing rendering
	Graphics.initBlend()
	Screen.clear(grey) 
	
	Graphics.drawLine(21, 940, 489, 489, white)
	
	Font.setPixelSizes(fnt, 22)
	h,m,s = System.getTime()
	Font.print(fnt, 726, 34, string.format("%02d:%02d",h,m), white)--Draw time
	life = System.getBatteryPercentage()
	Font.print(fnt, 830, 34, life .. "%", white)--Draw battery
	Graphics.drawImage(888, 41, imgBattery)
	Graphics.fillRect(891, 891+(life/5.2), 45, 53, white)
	Graphics.drawImage(43, 28, imgAvatar)
	Graphics.drawImage(45, 496, imgCont)
	
	Graphics.drawImage(850, 507, btnX)
	Font.print(fnt, 878, 503, "Start", white)
	if bottomMenu == false then 
	Graphics.drawImage(27, 108, imgCart)
	Font.setPixelSizes(fnt, 27)
	Font.print(fnt, 60, 104, app_title, blue)--Draw title
	else
	Font.setPixelSizes(fnt, 27)
	if menuSel==1 then
	menuX=240-2
	Font.print(fnt, menuX+8, 452, "News", blue)
	elseif menuSel==2 then
	menuX=322-2	
	Font.print(fnt, menuX+4, 452, "Store", blue)
	elseif menuSel==3 then
	menuX=404-2	
	Font.print(fnt, menuX+5, 452, "Album", blue)
	elseif menuSel==4 then
	menuX=486-2	
	Font.print(fnt, menuX-5, 452, "Controlls", blue)
	elseif menuSel==5 then
	menuX=568-2	
	Font.print(fnt, menuX-30, 452, "System Settings", blue)
	elseif menuSel==6 then
	menuX=650-2	
	Font.print(fnt, menuX+16, 452, "Exit", blue)
	end
	Graphics.drawImage(menuX, 378-2, btnMenuSel)

	end
	Graphics.drawImage(240, 378, btnMenu1)
	Graphics.drawImage(322, 378, btnMenu2)
	Graphics.drawImage(404, 378, btnMenu3)
	Graphics.drawImage(486, 378, btnMenu4)
	Graphics.drawImage(568, 378, btnMenu5)
	Graphics.drawImage(650, 378, btnMenu6)
		
		-- Drawing Filebrowser
		base_y = 85
		for l, file in pairs(files_table) do
			if (base_y > 960) then
				break
			end
			if (l >= master_index) then
				if (l==p) then
					base_y2 = base_y
					if (base_y) == 0 then
						base_y = 50
				end
					if bottomMenu == false then 
					Graphics.fillRect(base_y-6,base_y+198,152-6,152+198,blue) 
					end
					color = red
					if (base_y) == 2 then
						base_y = 50
					end
				else
					color = white
				end
				CropPrint(base_y,152,file.name,color, file.icon)
				base_y = base_y + 200
			end
		end
	
	-- Terminating rendering phase
	Graphics.termBlend()
	
		-- Filebrowser navigation
		if (Controls.check(pad,SCE_CTRL_CROSS) and not Controls.check(oldpad,SCE_CTRL_CROSS)) then
			if bottomMenu == false then
			System.launchApp(files_table[p].name)
			else
			SelectBottomMenu()
			end
		elseif (Controls.check(pad,SCE_CTRL_UP)) and not (Controls.check(oldpad,SCE_CTRL_UP)) then
			if bottomMenu == true then 
			bottomMenu = false
			Sound.play(click, NO_LOOP)
			end
		elseif (Controls.check(pad,SCE_CTRL_LEFT)) and not (Controls.check(oldpad,SCE_CTRL_LEFT)) then
			Sound.play(click, NO_LOOP)
			if bottomMenu == false then 
			p = p - 1
			if p>0 then
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
			end	
			if (p >= 1) then 
				master_index = p - 3
			end
			else
				menuSel = menuSel - 1
				if (menuSel<1) then
				menuSel=6
				end
			end
		elseif (Controls.check(pad,SCE_CTRL_RIGHT)) and not (Controls.check(oldpad,SCE_CTRL_RIGHT)) then
			Sound.play(click, NO_LOOP)
			if bottomMenu == false then 
			p = p + 1
			if p<=#files_table then
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
			end
			if (p >= 3) then 
				master_index = p - 3
			end
			else
				menuSel = menuSel + 1
				if (menuSel>6) then
				menuSel=1
				end
			end
		elseif (Controls.check(pad,SCE_CTRL_DOWN)) and not (Controls.check(oldpad,SCE_CTRL_DOWN)) then
			if bottomMenu == false then 
			bottomMenu = true 
			Sound.play(click, NO_LOOP)
			end
		end
		
		if p < 1 then
			p = #files_table
			if p >= 4 then 
				master_index = p - 3
			end
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
		elseif p > #files_table then
			master_index = 0
			p = 1
			info = System.extractSfo(working_dir .. "/" .. files_table[p].name .. "/sce_sys/param.sfo")
			app_title = info.title
		end

	-- Refreshing screen and oldpad
	Screen.flip()
	oldpad = pad
end
